""" 
Using the parseClass, build a topology that speficies a parser to parse
these sentences.  

turn step  Sentences
Turn left.
Step forward.
"""

import sys

from parseClass import ParseClass

totalSentences = -1#set explicitly
lengthOfLongestSentence = -1 #set explicitly
neal = None
sim = None
simName = None
spinnVersion = None

def addTurnSentences(parser):
    parser.addSentence(['turn','left','.'])
    turnState = parser.addState()
    parser.addTransition(parser.startState,turnState)
    parser.addTransitionOnWord('turn',turnState)
    turnLeftState = parser.addState()
    parser.addTransition(turnState,turnLeftState)
    parser.addTransitionOnWord('left',turnLeftState)
    tLPFinalState = parser.addState()
    parser.addTransition(turnLeftState,tLPFinalState)
    parser.addTransitionOnWord('.',tLPFinalState)
    return [tLPFinalState]

def linkInSink(spikeSource,sinkCell):
    global simName
    global neal
    if (simName == 'spinnaker'):
        connector = [(0,0,1.0, neal.DELAY)]
        neal.nealProjection(spikeSource,sinkCell,connector,'inhibitory') 


#spinnaker crashes if a spike source isn't connected to
#something.  Make the something here.
def allocateSinks(firstSink,spikeGenerators):
    global simName
    global sim
    if (simName != 'spinnaker'):
        return
    sinkCell=sim.Population(1,sim.IF_cond_exp,{})
    for sinkNumber  in range (firstSink,7):
        linkInSink(spikeGenerators[sinkNumber],sinkCell)

def setupTestSentences(parser,spikeGenerators,sentence):
    if (sentence == 0):
        parser.testTurnOnWord("turn",spikeGenerators[1])
        parser.testTurnOnWord("left",spikeGenerators[2])
        parser.testTurnOnWord(".",spikeGenerators[3])
        allocateSinks(4,spikeGenerators)
    elif (sentence == 1):
        parser.testTurnOnWord("step",spikeGenerators[1])
        parser.testTurnOnWord("forward",spikeGenerators[2])
        parser.testTurnOnWord(".",spikeGenerators[3])
        allocateSinks(4,spikeGenerators)
    elif (sentence == 2):
        parser.testTurnOnWord("put",spikeGenerators[1])
        parser.testTurnOnWord("the",spikeGenerators[2])
        parser.testTurnOnWord("yellow",spikeGenerators[3])
        parser.testTurnOnWord("banana",spikeGenerators[4])
        parser.testTurnOnWord("in",spikeGenerators[5])
        parser.testTurnOnWord("room",spikeGenerators[6])
        parser.testTurnOnWord("1",spikeGenerators[7])
        parser.testTurnOnWord("1",spikeGenerators[8])
        parser.testTurnOnWord(".",spikeGenerators[9])
        allocateSinks(10,spikeGenerators)        


#access functions for variables from this file
def getTotalSentences():
    return totalSentences

def getLengthOfLongestSentence():
    return lengthOfLongestSentence

#---main 
def main(simNameInput,simInput,nealInput,spinnVersionInput):
    global neal
    global sim
    global simName
    global spinnVersion

    global totalSentences
    global lengthOfLongestSentence

    #allocate neal and a parser
    neal = nealInput
    sim = simInput
    simName = simNameInput
    spinnVersion = spinnVersionInput
    parser = ParseClass(simName,sim,neal,spinnVersion)

    #specify the sentences you want to parse.
    tFinalStates = addTurnSentences(parser)

    #specify the step forward sentence.
    parser.addSentence(['step','forward','.']) 
    stepState = parser.addStateToNewStateOnWord(parser.startState,'step')
    stepForwardState = parser.addStateToNewStateOnWord(stepState,'forward')
    stepForwardFinalState = parser.addStateToNewStateOnWord(stepForwardState,'.')

    parser.addSentence(['put','the','yellow','banana','in','room','1','1','.'])
    putState = parser.addStateToNewStateOnWord(parser.startState,'put')
    putTheState = parser.addStateToNewStateOnWord(putState,'the')
    putTheYellowState = parser.addStateToNewStateOnWord(putTheState,'yellow')
    putTheYellowBananaState = parser.addStateToNewStateOnWord(putTheYellowState,'banana')
    putTheYellowBananaInState = parser.addStateToNewStateOnWord(putTheYellowBananaState,'in')
    putTheYellowBananaInRoomState = parser.addStateToNewStateOnWord(putTheYellowBananaInState,'room')
    putTheYellowBananaInRoom1State = parser.addStateToNewStateOnWord(putTheYellowBananaInRoomState,'1')
    #There is a bug here because putTheYellowBanananInRoom1State suppresses the
    #word 1.  Make a temporary state and slide to it.
    putTheYellowBananaInRoom1StateA = parser.addEmptyTransitionState(
        putTheYellowBananaInRoom1State)

    putTheYellowBananaInRoom11State = parser.addStateToNewStateOnWord(putTheYellowBananaInRoom1StateA,'1')
    putTheYellowBananaInRoom11FinalState = parser.addStateToNewStateOnWord(putTheYellowBananaInRoom11State,'.')

    totalSentences = 3
    lengthOfLongestSentence = 9

    #optionally, print out information about the parser
    parser.printWords()
    #parser.printStateTransitions()
    #parser.printWordTransitions()

    print "Final states in order"
    print tFinalStates, stepForwardFinalState,putTheYellowBananaInRoom11FinalState

    #allocate the topology
    parser.createNeurons()
    parser.recordNeurons()
    parser.createCAs()
    parser.createTransitionSynapses()

    #access the topology via the parser
    return parser



