"""
"""


import sys

fUseSpikeServer = True
#fUseSpikeServer = False

from Tkinter import Tk, Canvas, BOTH
from Tkinter import *
from spikeServeSpinn8 import spikeQueue

from ttk import Frame, Button, Style
from spinnman import constants


import math
#import time

class Environment(Frame):
    direction = 0.0
    locationX = 0.0
    locationY = 0.0

    lastSpinnUpdate = -210
    lastSpinnNewPic = -210
    numFiles = 0
    numUserFiles = 0

    gotCommandFromSpinnaker = False


    def __init__(self, parent):
        self.fileNum = 0
        Frame.__init__(self, parent)   
        self.toSpinQ = spikeQueue()
        
        #set up call back to interact with agent
        self.after(200,self.getSpinnInputOutput)

        self.parent = parent        
        self.initUI()

    nestInputLines = 0
    #get the actions from the text file created in cabot3X.py
    def getNewNestInput(self,fileHandle):
        lineCount = 0
        for inpLine in fileHandle:
            lineCount += 1
            if (lineCount > self.nestInputLines):
                splitInp = inpLine.split()
                print "get action",inpLine,splitInp
                action = int(splitInp[0])
                fileHandle.close()
                if (splitInp.__len__() > 1):
                    actionTime = int(splitInp[1])
                    return [lineCount,action,actionTime]
                else:
                    return [lineCount,action,0]
                
        fileHandle.close()
        return [lineCount,-1]

    def getSpinnInputOutput(self):
        if (spikeQueue.fHaveCommandFromBoard):
            self.processCommandFromBoard(spikeQueue.getCommandFromBoard())
            spikeQueue.fHaveCommandFromBoard = False
        self.toSpinQ.sendWord()
        self.after(200,self.getSpinnInputOutput)

    def processTextInput (self, textInput):
        #clear whitespace before and after
        input = textInput.rstrip()
        input = input.lstrip()

        #test for characters.
        if input == "l":
            self.toSpinQ.writeSentence([-1,0,1,2],4)
        elif input == "f":
            self.toSpinQ.writeSentence([-1,3,4,2],4)
        else:
            print "bad text input ", textInput


    def dumpBinCount(self):
        print 'dumpBinCount'
        self.update()
        self.reDraw()
        return
        fileName = "..data/userTest" + str(self.numUserFiles) + ".txt"
        file = open(fileName,"w")
        file.write(time.asctime())
        file.write("\n")
        file.close()
        self.numUserFiles = 1
        self.toSpinQ.addConditionalTicks(1000)


    fPrintedCommand = False
    fPrintedNoCommand = False

    def processCommandFromBoard(self,commandNum):
        if (commandNum == 0):
            self.turnLeft()
        elif (commandNum == 1):
            self.turnRight()
        elif (commandNum == 2):
            self.moveForward()
        elif (commandNum == 3):
            self.moveBack()
        else:
            print ("environment ignores action ", commandNum)


    #-----Functions for drawing the environment
    def reDraw(self):
        a = 1
        

    def clipPoint(self,pointFront,pointBack):
        slope = (pointFront[0]-pointBack[0])/(pointFront[2]-pointBack[2])
        #print "slope", slope, pointFront,pointBack

        #b = y - mx = y-slope*x solve for b
        b = pointFront[0]-(slope*pointFront[2])

        #get x intercept,  y = 0, b = -slope(x), x = b/-slope
        #x = (b/slope)*-1
        #print b,x
        #get y intercept x = 0, y=b

        
        pointBack[2] = 0
        #offset * foveal length (what do we do when b is between -5 and 2.5)
        #pointBack[0] = b*20
        if b < 0:
            pointBack[0] = -500
        else:
            pointBack[0] = 500
    
        return pointBack

    #-----Functions for moving
    def printPosition(self):
        print (self.direction,self.locationX,self.locationY)

    def moveForward(self):
        if self.direction == 0.0:
            self.locationX = self.locationX + 1.0
        elif self.direction == 90.0:
            self.locationY = self.locationY + 1.0
        elif self.direction == 180.0:
            self.locationX = self.locationX - 1.0
        elif self.direction == 270.0:
            self.locationY = self.locationY - 1.0
        self.printPosition()

    def turnLeft (self):
        self.direction = self.direction - 90.0
        self.direction = (self.direction % 360.0)
        self.printPosition()

    #send the sentence when you hit return
    def keyHandler(self,event):
        #print "keyhandler", repr(event.char)
        if (event.char == '\r'):
            text = self.editBox.get(1.0,END)
            self.editBox.delete(1.0,END)
            self.processTextInput(text)
            #self.putTextInFile(text)

    #set up the tickle frame with and edit box, buttons
    def initUI(self):
        self.parent.title("Turn Step Environment")        
        self.pack(fill=BOTH, expand=1)

        self.canvas = Canvas(self)

        self.canvas.pack(fill=BOTH, expand=1)

        quitButton = Button(self, text="Quit", command=self.quit)
        quitButton.place(x=0, y=0)
        printButton = Button(self, text="Print", command=self.printPosition)
        printButton.place(x=420, y=0)

        self.editBox = Text(self,height=1, width=50)
        self.editBox.place(x=0, y=25)
        self.editBox.bind("<Key>",self.keyHandler)
    #end of class

def main():
    print "main"
    root = Tk()
    env = Environment(root)
    root.geometry("500x200+300+300")
    root.mainloop()  


if __name__ == '__main__':
    main()  
